//+------------------------------------------------------------------+
//|                                         Blessing System - V1.mq4 |
//|                                         http://www.forex-tsd.com |
//+------------------------------------------------------------------+


#property copyright "Copyright  2007"
#property link      "http://www.forex-tsd.com"


extern string  strategy="==== Strategic Settings ====================";

extern double  TakeProfit      = 27;
       double  stopLoss        = 1000; 
extern int     MaxTrades       = 20;            //EURUSD H1 best
extern double  Multiplier      = 2;
       double  MaxLot          = 1;
extern int     D               = 20;
extern int     SL              = 20;

extern string  extra="==== Extraneous Settings ====================";
extern string  Expert_Name     = "V1";
extern int     Slippage        = 10;
extern bool    UseSound        = false;
extern string  SoundFile       = "alert.wav";



   // Internal Globals
   
double  s=0;
int c;
double Lots, InitLots, Long, Short;
double Last=EMPTY_VALUE;


//+------------------------------------------------------------------+

int init(){return(0);}

//+------------------------------------------------------------------+

int deinit(){return(0);}

//+------------------------------------------------------------------+

int start()
{


   double Price=iClose(NULL,0,0);
   int orderCount=0;
   double spread=(Ask-Bid)/Point;
   
   
   Print("Spread=",spread,"; c=",c);


   if (PositionsCurrentlyExist()==false) 
      s=0;


   
   for(int i=0;i<OrdersTotal();i++) 
   { 
      OrderSelect(i,SELECT_BY_POS,MODE_TRADES);
      if(OrderSymbol()==Symbol() && OrderComment()==Expert_Name) 
      {  
         orderCount++;
         if(OrderType()==OP_BUY) s=1;
         if(OrderType()==OP_SELL) s=2;
         Last=OrderOpenPrice();
      }
   }



   InitLots=MathCeil(AccountBalance()/6000)/100;
   Lots=InitLots;
   Lots=MathFloor(Lots*100)/100;
   if (Lots<0.01) Lots=0.01;


   stopLoss=SL+(MaxTrades-1)*D;
   
   
   for (int j=0;j<orderCount;j++) 
   {
      Lots=Multiplier*Lots; 
      stopLoss=stopLoss-D; 
   }

   if (AccountBalance()>6000) MaxLot=MathFloor(AccountBalance()/40)/100;
   if (Lots>MaxLot) Lots=MaxLot; 

   if (Lots>100) Lots=100; 
   if (Lots<0.01) Lots=0.01;


  
   if (orderCount==0 || Long==0) 
      Long=1000;
      
   if (orderCount==0 || Short==0) 
      Short=-1000;


   if (orderCount>0)
   {
      if ((s==1)&&(Long>Last)) Long=Last;
      if ((s==2)&&(Short<Last)) Short=Last;
   }

   if (orderCount==MaxTrades) c=1;
   if (orderCount==0) c=0;


   if (s==0)    
      if(AccountFreeMargin()<(1000*Lots))
      {
         Print("We have no money.  Free Margin = ", AccountFreeMargin());
         return(0);  
      }




   if ((s==0)&&(c==0))  
   {
      OpenBuy();
      s=1; 
      return(0);
   }  


   if (orderCount<MaxTrades) 
   {
      if ((s==1)&&(Price<(Last-(D+spread)*Point))&&(c==0))          
         {OpenBuy();s=1; return(0);}

      if ((s==2)&&(Price>(Last+(D)*Point))&&(c==0))                
         {OpenSell();s=2; return(0);}

      if ((s==1)&&(Price>(Long+(TakeProfit-1)*Point)))              
         {closeAllOrders();s=0; return(0);}

      if ((s==2)&&(Price<(Short-(TakeProfit-1+spread)*Point)))      
         {closeAllOrders();s=0; return(0);} 

    }
  
    
   return (0); 
   
   
}//end start



//+------------------------------------------------------------------+
// - - - - - - FUNCTIONS - - - - - - -
//+------------------------------------------------------------------+

bool PositionsCurrentlyExist()   {
   for(int i=0;i<OrdersTotal(); i++)  {
      OrderSelect(i,SELECT_BY_POS,MODE_TRADES);
         if(OrderSymbol()==Symbol() && OrderComment()==Expert_Name) return(True);
         else return(false); }   }
/*
//+------------------------------------------------------------------+

void TrailingPositionsBuy(int trailingStop) { 
   for(int i=0;i<OrdersTotal();i++) { 
      OrderSelect(i,SELECT_BY_POS,MODE_TRADES);
         if(OrderSymbol()==Symbol() && OrderComment()==Expert_Name) { 
            if(OrderType()==OP_BUY) { 
               if(Bid-OrderOpenPrice()>trailingStop*Point) { 
                  if(OrderStopLoss()<Bid-trailingStop*Point || OrderStopLoss()==0)   {
                     ModifyStopLoss(Bid-trailingStop*Point); }}}}}} 

//+------------------------------------------------------------------+

void TrailingPositionsSell(int trailingStop) { 
   for(int i=0;i<OrdersTotal();i++) { 
      OrderSelect(i,SELECT_BY_POS,MODE_TRADES);
         if(OrderSymbol()==Symbol() && OrderComment()==Expert_Name) { 
            if(OrderType()==OP_SELL) { 
               if(OrderOpenPrice()-Ask>trailingStop*Point) { 
                  if(OrderStopLoss()>Ask+trailingStop*Point || OrderStopLoss()==0)  {  
                     ModifyStopLoss(Ask+trailingStop*Point);}}}}}} 
 
//+------------------------------------------------------------------+

void ModifyStopLoss(double ldStopLoss) { 
   bool fm;
   fm = OrderModify(OrderTicket(),OrderOpenPrice(),ldStopLoss,OrderTakeProfit(),0,0); 
   if (fm && UseSound) PlaySound(SoundFile); 
} 
*/
//+------------------------------------------------------------------+

void OpenBuy() { 
   double ldLot, ldStop, ldTake; 
   string lsComm; 
   ldLot = GetSizeLot(); 
   ldStop = Ask-Point*stopLoss; 
   ldTake = NormalizeDouble(GetTakeProfitBuy(),Digits); 
   lsComm = GetCommentForOrder(); 
   OrderSend(Symbol(),OP_BUY,ldLot,NormalizeDouble(Ask,Digits),Slippage,ldStop,ldTake,lsComm,0,0,Blue); 
   if (UseSound) PlaySound(SoundFile);   }
 
//+------------------------------------------------------------------+

void OpenSell() 
{ 
   double ldLot, ldStop, ldTake; 
   string lsComm; 
   ldLot = GetSizeLot(); 
   ldStop = Bid+Point*stopLoss; 
   ldTake = NormalizeDouble(GetTakeProfitSell(),Digits); 
   lsComm = GetCommentForOrder(); 
   OrderSend(Symbol(),OP_SELL,ldLot,NormalizeDouble(Bid,Digits),Slippage,ldStop,ldTake,lsComm,0,0,Red); 
   if (UseSound) PlaySound(SoundFile);   
   
}

// close all open and pending orders

//+------------------------------------------------------------------+

void closeAllOrders()  

{
   for(int c=0;c<OrdersTotal();c++) {
     OrderSelect(c,SELECT_BY_POS,MODE_TRADES); 
         if (OrderSymbol()==Symbol() && OrderComment()==Expert_Name && OrderType()==OP_BUY)  {
            OrderClose(OrderTicket(), OrderLots(),Bid,Slippage, White);  }
         if (OrderSymbol()==Symbol() && OrderComment()==Expert_Name && OrderType()==OP_SELL)  {
            OrderClose(OrderTicket(), OrderLots(), Ask,Slippage, White);  }   
         if (OrderSymbol()==Symbol() && OrderComment()==Expert_Name && OrderType() > 1)  { OrderDelete(OrderTicket()); }
   }
} 

// end closeAllOrders() 

//+------------------------------------------------------------------+

string GetCommentForOrder() { return(Expert_Name); } 
double GetSizeLot() { return(Lots); } 
double GetTakeProfitBuy() { return(Ask+TakeProfit*Point); } 
double GetTakeProfitSell() { return(Bid-TakeProfit*Point); } 

//+------------------------------------------------------------------+

